/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.76
        Device            :  PIC16F18346
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.00
        MPLAB 	          :  MPLAB X 5.10	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set SW4 aliases
#define SW4_TRIS                 TRISAbits.TRISA0
#define SW4_LAT                  LATAbits.LATA0
#define SW4_PORT                 PORTAbits.RA0
#define SW4_WPU                  WPUAbits.WPUA0
#define SW4_OD                   ODCONAbits.ODCA0
#define SW4_ANS                  ANSELAbits.ANSA0
#define SW4_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define SW4_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define SW4_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define SW4_GetValue()           PORTAbits.RA0
#define SW4_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define SW4_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define SW4_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define SW4_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define SW4_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define SW4_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define SW4_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define SW4_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set SW6 aliases
#define SW6_TRIS                 TRISAbits.TRISA1
#define SW6_LAT                  LATAbits.LATA1
#define SW6_PORT                 PORTAbits.RA1
#define SW6_WPU                  WPUAbits.WPUA1
#define SW6_OD                   ODCONAbits.ODCA1
#define SW6_ANS                  ANSELAbits.ANSA1
#define SW6_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define SW6_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define SW6_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define SW6_GetValue()           PORTAbits.RA1
#define SW6_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define SW6_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define SW6_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define SW6_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define SW6_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define SW6_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define SW6_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define SW6_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set RA2 procedures
#define RA2_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define RA2_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define RA2_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define RA2_GetValue()              PORTAbits.RA2
#define RA2_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define RA2_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define RA2_SetPullup()             do { WPUAbits.WPUA2 = 1; } while(0)
#define RA2_ResetPullup()           do { WPUAbits.WPUA2 = 0; } while(0)
#define RA2_SetAnalogMode()         do { ANSELAbits.ANSA2 = 1; } while(0)
#define RA2_SetDigitalMode()        do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set SW12 aliases
#define SW12_PORT                 PORTAbits.RA3
#define SW12_WPU                  WPUAbits.WPUA3
#define SW12_GetValue()           PORTAbits.RA3
#define SW12_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define SW12_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)

// get/set IRin aliases
#define IRin_TRIS                 TRISAbits.TRISA4
#define IRin_LAT                  LATAbits.LATA4
#define IRin_PORT                 PORTAbits.RA4
#define IRin_WPU                  WPUAbits.WPUA4
#define IRin_OD                   ODCONAbits.ODCA4
#define IRin_ANS                  ANSELAbits.ANSA4
#define IRin_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define IRin_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define IRin_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define IRin_GetValue()           PORTAbits.RA4
#define IRin_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define IRin_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define IRin_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define IRin_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define IRin_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define IRin_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define IRin_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define IRin_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set IRinPower aliases
#define IRinPower_TRIS                 TRISAbits.TRISA5
#define IRinPower_LAT                  LATAbits.LATA5
#define IRinPower_PORT                 PORTAbits.RA5
#define IRinPower_WPU                  WPUAbits.WPUA5
#define IRinPower_OD                   ODCONAbits.ODCA5
#define IRinPower_ANS                  ANSELAbits.ANSA5
#define IRinPower_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define IRinPower_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define IRinPower_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define IRinPower_GetValue()           PORTAbits.RA5
#define IRinPower_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define IRinPower_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define IRinPower_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define IRinPower_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define IRinPower_SetPushPull()        do { ODCONAbits.ODCA5 = 0; } while(0)
#define IRinPower_SetOpenDrain()       do { ODCONAbits.ODCA5 = 1; } while(0)
#define IRinPower_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define IRinPower_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set SW3 aliases
#define SW3_TRIS                 TRISBbits.TRISB4
#define SW3_LAT                  LATBbits.LATB4
#define SW3_PORT                 PORTBbits.RB4
#define SW3_WPU                  WPUBbits.WPUB4
#define SW3_OD                   ODCONBbits.ODCB4
#define SW3_ANS                  ANSELBbits.ANSB4
#define SW3_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define SW3_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define SW3_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define SW3_GetValue()           PORTBbits.RB4
#define SW3_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define SW3_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define SW3_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define SW3_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define SW3_SetPushPull()        do { ODCONBbits.ODCB4 = 0; } while(0)
#define SW3_SetOpenDrain()       do { ODCONBbits.ODCB4 = 1; } while(0)
#define SW3_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define SW3_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set RB5 procedures
#define RB5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define RB5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define RB5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define RB5_GetValue()              PORTBbits.RB5
#define RB5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define RB5_SetPullup()             do { WPUBbits.WPUB5 = 1; } while(0)
#define RB5_ResetPullup()           do { WPUBbits.WPUB5 = 0; } while(0)
#define RB5_SetAnalogMode()         do { ANSELBbits.ANSB5 = 1; } while(0)
#define RB5_SetDigitalMode()        do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set SW5 aliases
#define SW5_TRIS                 TRISBbits.TRISB6
#define SW5_LAT                  LATBbits.LATB6
#define SW5_PORT                 PORTBbits.RB6
#define SW5_WPU                  WPUBbits.WPUB6
#define SW5_OD                   ODCONBbits.ODCB6
#define SW5_ANS                  ANSELBbits.ANSB6
#define SW5_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define SW5_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define SW5_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define SW5_GetValue()           PORTBbits.RB6
#define SW5_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define SW5_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define SW5_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define SW5_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)
#define SW5_SetPushPull()        do { ODCONBbits.ODCB6 = 0; } while(0)
#define SW5_SetOpenDrain()       do { ODCONBbits.ODCB6 = 1; } while(0)
#define SW5_SetAnalogMode()      do { ANSELBbits.ANSB6 = 1; } while(0)
#define SW5_SetDigitalMode()     do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set RB7 procedures
#define RB7_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define RB7_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define RB7_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define RB7_GetValue()              PORTBbits.RB7
#define RB7_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define RB7_SetPullup()             do { WPUBbits.WPUB7 = 1; } while(0)
#define RB7_ResetPullup()           do { WPUBbits.WPUB7 = 0; } while(0)
#define RB7_SetAnalogMode()         do { ANSELBbits.ANSB7 = 1; } while(0)
#define RB7_SetDigitalMode()        do { ANSELBbits.ANSB7 = 0; } while(0)

// get/set SW2 aliases
#define SW2_TRIS                 TRISCbits.TRISC0
#define SW2_LAT                  LATCbits.LATC0
#define SW2_PORT                 PORTCbits.RC0
#define SW2_WPU                  WPUCbits.WPUC0
#define SW2_OD                   ODCONCbits.ODCC0
#define SW2_ANS                  ANSELCbits.ANSC0
#define SW2_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define SW2_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define SW2_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define SW2_GetValue()           PORTCbits.RC0
#define SW2_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define SW2_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define SW2_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define SW2_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define SW2_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define SW2_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define SW2_SetAnalogMode()      do { ANSELCbits.ANSC0 = 1; } while(0)
#define SW2_SetDigitalMode()     do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set SW1 aliases
#define SW1_TRIS                 TRISCbits.TRISC1
#define SW1_LAT                  LATCbits.LATC1
#define SW1_PORT                 PORTCbits.RC1
#define SW1_WPU                  WPUCbits.WPUC1
#define SW1_OD                   ODCONCbits.ODCC1
#define SW1_ANS                  ANSELCbits.ANSC1
#define SW1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define SW1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define SW1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define SW1_GetValue()           PORTCbits.RC1
#define SW1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define SW1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define SW1_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define SW1_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define SW1_SetPushPull()        do { ODCONCbits.ODCC1 = 0; } while(0)
#define SW1_SetOpenDrain()       do { ODCONCbits.ODCC1 = 1; } while(0)
#define SW1_SetAnalogMode()      do { ANSELCbits.ANSC1 = 1; } while(0)
#define SW1_SetDigitalMode()     do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set LED aliases
#define LED_TRIS                 TRISCbits.TRISC2
#define LED_LAT                  LATCbits.LATC2
#define LED_PORT                 PORTCbits.RC2
#define LED_WPU                  WPUCbits.WPUC2
#define LED_OD                   ODCONCbits.ODCC2
#define LED_ANS                  ANSELCbits.ANSC2
#define LED_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define LED_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define LED_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define LED_GetValue()           PORTCbits.RC2
#define LED_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define LED_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define LED_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define LED_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define LED_SetPushPull()        do { ODCONCbits.ODCC2 = 0; } while(0)
#define LED_SetOpenDrain()       do { ODCONCbits.ODCC2 = 1; } while(0)
#define LED_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define LED_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set SW9 aliases
#define SW9_TRIS                 TRISCbits.TRISC3
#define SW9_LAT                  LATCbits.LATC3
#define SW9_PORT                 PORTCbits.RC3
#define SW9_WPU                  WPUCbits.WPUC3
#define SW9_OD                   ODCONCbits.ODCC3
#define SW9_ANS                  ANSELCbits.ANSC3
#define SW9_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define SW9_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define SW9_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define SW9_GetValue()           PORTCbits.RC3
#define SW9_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define SW9_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define SW9_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define SW9_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define SW9_SetPushPull()        do { ODCONCbits.ODCC3 = 0; } while(0)
#define SW9_SetOpenDrain()       do { ODCONCbits.ODCC3 = 1; } while(0)
#define SW9_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define SW9_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set SW10 aliases
#define SW10_TRIS                 TRISCbits.TRISC4
#define SW10_LAT                  LATCbits.LATC4
#define SW10_PORT                 PORTCbits.RC4
#define SW10_WPU                  WPUCbits.WPUC4
#define SW10_OD                   ODCONCbits.ODCC4
#define SW10_ANS                  ANSELCbits.ANSC4
#define SW10_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define SW10_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define SW10_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define SW10_GetValue()           PORTCbits.RC4
#define SW10_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define SW10_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define SW10_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define SW10_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define SW10_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define SW10_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define SW10_SetAnalogMode()      do { ANSELCbits.ANSC4 = 1; } while(0)
#define SW10_SetDigitalMode()     do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set SW11 aliases
#define SW11_TRIS                 TRISCbits.TRISC5
#define SW11_LAT                  LATCbits.LATC5
#define SW11_PORT                 PORTCbits.RC5
#define SW11_WPU                  WPUCbits.WPUC5
#define SW11_OD                   ODCONCbits.ODCC5
#define SW11_ANS                  ANSELCbits.ANSC5
#define SW11_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define SW11_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define SW11_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define SW11_GetValue()           PORTCbits.RC5
#define SW11_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define SW11_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define SW11_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define SW11_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define SW11_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define SW11_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define SW11_SetAnalogMode()      do { ANSELCbits.ANSC5 = 1; } while(0)
#define SW11_SetDigitalMode()     do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set SW8 aliases
#define SW8_TRIS                 TRISCbits.TRISC6
#define SW8_LAT                  LATCbits.LATC6
#define SW8_PORT                 PORTCbits.RC6
#define SW8_WPU                  WPUCbits.WPUC6
#define SW8_OD                   ODCONCbits.ODCC6
#define SW8_ANS                  ANSELCbits.ANSC6
#define SW8_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define SW8_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define SW8_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define SW8_GetValue()           PORTCbits.RC6
#define SW8_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define SW8_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define SW8_SetPullup()          do { WPUCbits.WPUC6 = 1; } while(0)
#define SW8_ResetPullup()        do { WPUCbits.WPUC6 = 0; } while(0)
#define SW8_SetPushPull()        do { ODCONCbits.ODCC6 = 0; } while(0)
#define SW8_SetOpenDrain()       do { ODCONCbits.ODCC6 = 1; } while(0)
#define SW8_SetAnalogMode()      do { ANSELCbits.ANSC6 = 1; } while(0)
#define SW8_SetDigitalMode()     do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set SW7 aliases
#define SW7_TRIS                 TRISCbits.TRISC7
#define SW7_LAT                  LATCbits.LATC7
#define SW7_PORT                 PORTCbits.RC7
#define SW7_WPU                  WPUCbits.WPUC7
#define SW7_OD                   ODCONCbits.ODCC7
#define SW7_ANS                  ANSELCbits.ANSC7
#define SW7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define SW7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define SW7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define SW7_GetValue()           PORTCbits.RC7
#define SW7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define SW7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define SW7_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define SW7_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define SW7_SetPushPull()        do { ODCONCbits.ODCC7 = 0; } while(0)
#define SW7_SetOpenDrain()       do { ODCONCbits.ODCC7 = 1; } while(0)
#define SW7_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define SW7_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF0 pin functionality
 * @Example
    IOCAF0_ISR();
 */
void IOCAF0_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF0 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF0 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF0_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF0 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF0_SetInterruptHandler() method.
    This handler is called every time the IOCAF0 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(IOCAF0_InterruptHandler);

*/
extern void (*IOCAF0_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF0 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF0_SetInterruptHandler() method.
    This handler is called every time the IOCAF0 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF0_SetInterruptHandler(IOCAF0_DefaultInterruptHandler);

*/
void IOCAF0_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF1 pin functionality
 * @Example
    IOCAF1_ISR();
 */
void IOCAF1_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF1 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF1 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF1_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF1 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF1_SetInterruptHandler() method.
    This handler is called every time the IOCAF1 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(IOCAF1_InterruptHandler);

*/
extern void (*IOCAF1_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF1 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF1_SetInterruptHandler() method.
    This handler is called every time the IOCAF1 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF1_SetInterruptHandler(IOCAF1_DefaultInterruptHandler);

*/
void IOCAF1_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCAF3 pin functionality
 * @Example
    IOCAF3_ISR();
 */
void IOCAF3_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCAF3 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCAF3 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF3_SetInterruptHandler(MyInterruptHandler);

*/
void IOCAF3_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCAF3 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCAF3_SetInterruptHandler() method.
    This handler is called every time the IOCAF3 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF3_SetInterruptHandler(IOCAF3_InterruptHandler);

*/
extern void (*IOCAF3_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCAF3 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCAF3_SetInterruptHandler() method.
    This handler is called every time the IOCAF3 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCAF3_SetInterruptHandler(IOCAF3_DefaultInterruptHandler);

*/
void IOCAF3_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCBF4 pin functionality
 * @Example
    IOCBF4_ISR();
 */
void IOCBF4_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCBF4 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCBF4 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF4_SetInterruptHandler(MyInterruptHandler);

*/
void IOCBF4_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCBF4 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCBF4_SetInterruptHandler() method.
    This handler is called every time the IOCBF4 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF4_SetInterruptHandler(IOCBF4_InterruptHandler);

*/
extern void (*IOCBF4_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCBF4 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCBF4_SetInterruptHandler() method.
    This handler is called every time the IOCBF4 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF4_SetInterruptHandler(IOCBF4_DefaultInterruptHandler);

*/
void IOCBF4_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCBF6 pin functionality
 * @Example
    IOCBF6_ISR();
 */
void IOCBF6_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCBF6 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCBF6 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF6_SetInterruptHandler(MyInterruptHandler);

*/
void IOCBF6_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCBF6 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCBF6_SetInterruptHandler() method.
    This handler is called every time the IOCBF6 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF6_SetInterruptHandler(IOCBF6_InterruptHandler);

*/
extern void (*IOCBF6_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCBF6 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCBF6_SetInterruptHandler() method.
    This handler is called every time the IOCBF6 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCBF6_SetInterruptHandler(IOCBF6_DefaultInterruptHandler);

*/
void IOCBF6_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF0 pin functionality
 * @Example
    IOCCF0_ISR();
 */
void IOCCF0_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF0 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF0 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF0_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF0_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF0 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF0_SetInterruptHandler() method.
    This handler is called every time the IOCCF0 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF0_SetInterruptHandler(IOCCF0_InterruptHandler);

*/
extern void (*IOCCF0_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF0 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF0_SetInterruptHandler() method.
    This handler is called every time the IOCCF0 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF0_SetInterruptHandler(IOCCF0_DefaultInterruptHandler);

*/
void IOCCF0_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF1 pin functionality
 * @Example
    IOCCF1_ISR();
 */
void IOCCF1_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF1 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF1 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF1_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF1_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF1 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF1_SetInterruptHandler() method.
    This handler is called every time the IOCCF1 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF1_SetInterruptHandler(IOCCF1_InterruptHandler);

*/
extern void (*IOCCF1_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF1 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF1_SetInterruptHandler() method.
    This handler is called every time the IOCCF1 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF1_SetInterruptHandler(IOCCF1_DefaultInterruptHandler);

*/
void IOCCF1_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF3 pin functionality
 * @Example
    IOCCF3_ISR();
 */
void IOCCF3_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF3 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF3 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF3_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF3_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF3 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF3_SetInterruptHandler() method.
    This handler is called every time the IOCCF3 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF3_SetInterruptHandler(IOCCF3_InterruptHandler);

*/
extern void (*IOCCF3_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF3 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF3_SetInterruptHandler() method.
    This handler is called every time the IOCCF3 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF3_SetInterruptHandler(IOCCF3_DefaultInterruptHandler);

*/
void IOCCF3_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF4 pin functionality
 * @Example
    IOCCF4_ISR();
 */
void IOCCF4_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF4 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF4 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF4_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF4_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF4 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF4_SetInterruptHandler() method.
    This handler is called every time the IOCCF4 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF4_SetInterruptHandler(IOCCF4_InterruptHandler);

*/
extern void (*IOCCF4_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF4 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF4_SetInterruptHandler() method.
    This handler is called every time the IOCCF4 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF4_SetInterruptHandler(IOCCF4_DefaultInterruptHandler);

*/
void IOCCF4_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF5 pin functionality
 * @Example
    IOCCF5_ISR();
 */
void IOCCF5_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF5 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF5 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF5_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF5 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF5_SetInterruptHandler() method.
    This handler is called every time the IOCCF5 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(IOCCF5_InterruptHandler);

*/
extern void (*IOCCF5_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF5 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF5_SetInterruptHandler() method.
    This handler is called every time the IOCCF5 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF5_SetInterruptHandler(IOCCF5_DefaultInterruptHandler);

*/
void IOCCF5_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF6 pin functionality
 * @Example
    IOCCF6_ISR();
 */
void IOCCF6_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF6 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF6 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF6_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF6_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF6 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF6_SetInterruptHandler() method.
    This handler is called every time the IOCCF6 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF6_SetInterruptHandler(IOCCF6_InterruptHandler);

*/
extern void (*IOCCF6_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF6 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF6_SetInterruptHandler() method.
    This handler is called every time the IOCCF6 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF6_SetInterruptHandler(IOCCF6_DefaultInterruptHandler);

*/
void IOCCF6_DefaultInterruptHandler(void);


/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handler for the IOCCF7 pin functionality
 * @Example
    IOCCF7_ISR();
 */
void IOCCF7_ISR(void);

/**
  @Summary
    Interrupt Handler Setter for IOCCF7 pin interrupt-on-change functionality

  @Description
    Allows selecting an interrupt handler for IOCCF7 at application runtime
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    InterruptHandler function pointer.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF7_SetInterruptHandler(MyInterruptHandler);

*/
void IOCCF7_SetInterruptHandler(void (* InterruptHandler)(void));

/**
  @Summary
    Dynamic Interrupt Handler for IOCCF7 pin

  @Description
    This is a dynamic interrupt handler to be used together with the IOCCF7_SetInterruptHandler() method.
    This handler is called every time the IOCCF7 ISR is executed and allows any function to be registered at runtime.
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF7_SetInterruptHandler(IOCCF7_InterruptHandler);

*/
extern void (*IOCCF7_InterruptHandler)(void);

/**
  @Summary
    Default Interrupt Handler for IOCCF7 pin

  @Description
    This is a predefined interrupt handler to be used together with the IOCCF7_SetInterruptHandler() method.
    This handler is called every time the IOCCF7 ISR is executed. 
    
  @Preconditions
    Pin Manager intializer called

  @Returns
    None.

  @Param
    None.

  @Example
    PIN_MANAGER_Initialize();
    IOCCF7_SetInterruptHandler(IOCCF7_DefaultInterruptHandler);

*/
void IOCCF7_DefaultInterruptHandler(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/